/*-
 * #%L
 * Smile CDR - CDR
 * %%
 * Copyright (C) 2016 - 2024 Smile CDR, Inc.
 * %%
 * All rights reserved.
 * #L%
 */
package com.example.ips;

import ca.uhn.fhir.jpa.ips.api.IpsSectionContext;
import ca.uhn.fhir.jpa.ips.jpa.JpaSectionSearchStrategy;
import ca.uhn.fhir.jpa.searchparam.SearchParameterMap;
import ca.uhn.fhir.rest.param.TokenParam;
import jakarta.annotation.Nonnull;
import org.hl7.fhir.r4.model.Coverage;

public class InsuranceJpaSectionSearchStrategy extends JpaSectionSearchStrategy<Coverage> {

	@Override
	public void massageResourceSearch(
			@Nonnull IpsSectionContext<Coverage> theIpsSectionContext, SearchParameterMap theSearchParameterMap) {

		// Include the Organization reference in Coverage.payor
		theSearchParameterMap.addInclude(Coverage.INCLUDE_PAYOR);

		// We only want to include active Coverage resources
		theSearchParameterMap.add(Coverage.SP_STATUS, new TokenParam("active"));
	}
}
